package cz.moneta.test.dsl.cagw.oauth2;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.cagw.oauth2.token.TokenBuilder;
import cz.moneta.test.harness.endpoints.cagw.CaGwEndpoint;
import cz.moneta.test.harness.support.rest.Builders;
import cz.moneta.test.harness.support.rest.RestRequest;

public class Oauth2Builder {
    private final Harness harness;

    public Oauth2Builder(Harness harness) {
        this.harness = harness;
    }

    public TokenBuilder token() {
        return new TokenBuilder(harness);
    }

    private <RESP, B extends RestRequest<B, ?, RESP>> B getBuilder(Class<B> builderClass) {
        return Builders.newRestBuilder(builderClass, CaGwEndpoint.class, harness);
    }
}